define(["underscore","utils/Logger","utils/Localization","utils/CardType","utils/database/DBImporter","text!templates/ddl/create-user-variable.ddl"],function(e,t,a,r,n,i){function o(e){for(var t=Object.keys(e),a="",r=0;r<t.length;r++)a+=t[r]+" "+e[t[r]],r<t.length-1&&(a+=", ");return a}function s(e,t){var a="CREATE TABLE IF NOT EXISTS "+e+" ( id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT";return Object.keys(t).length>0&&(a+=", "),a+=o(t),a+=")"}var l=function(e){this.SQL=e,this.dbImporter=new n(e)},d=function(e,t,a,r,n){var i=a.shift();if(i){var o=i.name,s=t[o]?t[o]:t.dbImporter[o];i.tx?t.SQL.database.transaction(function(e){e.name=o,s.call(t,e,function(){d(e,t,a,r,n)},n)}):(e.name=o,s.call(t,e,function(){d(e,t,a,r,n)},n))}else"function"==typeof r&&r()};return l.prototype.createUserCardTable=function(t,n){var i,o=this,s=["original","txt_original","translation","txt_translation"];if(a.isMonoLingual())i=s;else{var l=["en","es","fr","it","de","esperanto","pt","ru","cn"];i=e.reduce(l,function(e,t){return e.push(t),e.push("txt_"+t),e},[])}this.SQL.executeSql(t,"CREATE TABLE IF NOT EXISTS user_card ( id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, card_stat_id INTEGER, "+e.reduce(i,function(e,t){return e+=t+" TEXT, "},"")+"typeCard TEXT, usage TEXT, genre TEXT, image TEXT, licence TEXT, sound TEXT, linked_card TEXT, tags TEXT, category TEXT, level INTEGER );",[],function(e){o.SQL._existingTables=null,o.SQL.executeSql(e,"insert into user_card (id) SELECT "+r.userCardDelimiterId+" WHERE NOT EXISTS (SELECT 1 FROM user_card where id = "+r.userCardDelimiterId+");",[],"function"==typeof n?n:o.SQL._nullDataHandler,o.SQL._errorHandler)},this.SQL._errorHandler)},l.prototype.createUserCategoryTable=function(e,t){var a={name:"TEXT",father_cat_id:"TEXT",priority:"INTEGER"},r=s("user_category",a);this.SQL.executeSql(e,r,[],"function"==typeof t?t:this.SQL._nullDataHandler,this.SQL._errorHandler)},l.prototype.createCategoryView=function(e,t){var a=this;this.SQL.database.transaction(function(e){a.SQL.executeSql(e,"CREATE VIEW if not exists unified_category_view as select cast((90000000 + id) as text) as id, name, '' as description, '' as type, father_cat_id, '' as image, priority, 1 as is_user_cat from user_category union select id, name, description, type, father_cat_id, image, priority, 0 as is_user_cat from category",[],t,a.SQL._errorHandler)})},l.prototype.createMosaContent=function(e,t,r,n){t.name="_createMosaContent",this.SQL.executeSql(t,"CREATE TABLE card( id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, card_stat_id INTEGER, original TEXT, txt_original TEXT, translation TEXT, txt_translation TEXT, trans_original TEXT,typeCard TEXT, usage TEXT, flags TEXT,genre TEXT, image TEXT, licence TEXT, sound TEXT, linked_card TEXT, tags TEXT, category TEXT, level INTEGER, row INTEGER, "+(a.LOCALIZED.HAS_PRONOUNCIATION?"phon TEXT,":"")+"pack_id TEXT );",[],this.SQL._nullDataHandler,this.SQL._errorHandler),this.SQL.executeSql(t,"CREATE INDEX IF NOT EXISTS index_card_selectToReview on card (level)",[],this.SQL._nullDataHandler,this.SQL._errorHandler),this.SQL.executeSql(t,"CREATE INDEX IF NOT EXISTS index_card_selectToReview on card (id, level)",[],this.SQL._nullDataHandler,this.SQL._errorHandler),this.SQL.executeSql(t,"CREATE INDEX IF NOT EXISTS index_card_toLearn on card (card_stat_id)",[],this.SQL._nullDataHandler,this.SQL._errorHandler),this.SQL.executeSql(t,"CREATE INDEX IF NOT EXISTS index_cardcategory on card (category, level)",[],this.SQL._nullDataHandler,this.SQL._errorHandler),this.SQL.executeSql(t,"CREATE INDEX IF NOT EXISTS index_tags on card (tags)",[],this.SQL._nullDataHandler,this.SQL._errorHandler),this.SQL.executeSql(t,"CREATE TABLE category( id TEXT NOT NULL PRIMARY KEY, name TEXT, description TEXT, type TEXT, father_cat_id TEXT, image TEXT, priority INTEGER );",[],this.SQL._nullDataHandler,this.SQL._errorHandler),this.SQL.executeSql(t,"CREATE INDEX IF NOT EXISTS index_category on category (father_cat_id, priority)",[],this.SQL._nullDataHandler,this.SQL._errorHandler),e(r,!1,n)},l.prototype.createMosaContentWithShippedCards=function(t,a){this.createMosaContent(e.bind(this.dbImporter.loadShippedCardsAndCategories,this.dbImporter),t,a)},l.prototype.createMosaContentWithDownloadedCards=function(r,n){var i=a.isContainerApp(),o=a.isHostedApp(),s=!a.LOCALIZED.LITE_VERSION&&a.getOriginallyShippedLocalized().LITE_VERSION,l=a.LOCALIZED.B2B&&o&&a.getOriginallyShippedLocalized().LITE_VERSION;(i||o)&&!s||l?(t.info("APP_SWITCH: load shipped cards for app: "+a.getAppVersion()),this.createMosaContent(e.bind(this.dbImporter.loadShippedCardsAndCategories,this.dbImporter),r,n)):(t.info("APP_SWITCH: load downloaded cards for app: "+a.getAppVersion()),this.createMosaContent(e.bind(this.dbImporter.loadDownloadedCardsAndCategories,this.dbImporter),r,n))},l.prototype.createMosaContentWithLatestContent=function(t,a,r){this.createMosaContent(e.bind(this.dbImporter.loadLatestCardAndCategories,this.dbImporter),t,a,r)},l.prototype.createMosaContentWithLatestContentFromS3=function(t,a,r){this.createMosaContent(e.bind(this.dbImporter.loadLatestCardAndCategoriesFromS3Content,this.dbImporter),t,a,r)},l.prototype.createCardStatTable=function(t,a){var r=this;this.SQL.getExistingTables(function(n){!1===e.includes(n,"card_stat")?r.SQL.executeSql(t,'CREATE TABLE "card_stat"( card_id INTEGER NOT NULL PRIMARY KEY, "firstViewTime" NUMERIC(10, 2) NOT NULL, "previousInterval" NUMERIC(10, 2) NOT NULL,  "interval" NUMERIC(10, 2) NOT NULL,  "previousDue" NUMERIC(10, 2) NOT NULL,  "due" NUMERIC(10, 2) NOT NULL,  "isDue" BOOLEAN NOT NULL,  "previousEFactor" NUMERIC(10, 2) NOT NULL,  "eFactor" NUMERIC(10, 2) NOT NULL,  "reponseNb" INTEGER NOT NULL,  "successiveRep" INTEGER NOT NULL,  "thinkingDuration" NUMERIC(10, 2) NOT NULL,  "totalDuration" NUMERIC(10, 2) NOT NULL,  "averageDuration" NUMERIC(10, 2) NOT NULL,  "nbOK" INTEGER NOT NULL,  "nbKO" INTEGER NOT NULL,  "tState" INTEGER NOT NULL,"favourite" BOOLEAN);',[],function(){r.SQL.executeSql(t,"CREATE INDEX IF NOT EXISTS index_card_selectToReview on card_stat (card_id, tState, due)",[],"function"==typeof a?a:r.SQL._nullDataHandler,r.SQL._errorHandler),r.SQL._existingTables=null},r.SQL._errorHandler):r.checkForFavouriteSupportWithoutTransaction(a)},t)},l.prototype.checkForFavouriteSupportWithoutTransaction=function(e){var t=this;t.SQL.database.transaction(function(a){t.SQL._hasTableColumn("card_stat","favourite",function(r){r?e():t.SQL.executeSql(a,"ALTER table card_stat ADD COLUMN favourite BOOLEAN",[],function(){e({shouldReloadDB:!0})},t.SQL._errorHandler)},a)})},l.prototype.createUserStat=function(t,a){var r=this;this.SQL.getExistingTables(function(n){!1===e.includes(n,"stat")?r.SQL.executeSql(t,"CREATE TABLE stat( id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, date NUMERIC(10, 2),  name TEXT NOT NULL, value TEXT);",[],function(){r.SQL._existingTables=null,r.SQL.executeSql(t,'insert into stat (date, name, value) VALUES ("'+(new Date).getTime()+'", "nbCardKnown","0");',[],function(){r.SQL.executeSql(t,'insert into stat (date, name, value) VALUES ("'+(new Date).getTime()+'", "nbCardReviewed","0");',[],function(){r.SQL.executeSql(t,'insert into stat (date, name, value) VALUES ("'+(new Date).getTime()+'", "dailyAppTime","0");',[],function(){r.SQL.executeSql(t,'insert into stat (date, name, value) VALUES ("'+(new Date).getTime()+'", "nbCardMature","0");',[],"function"==typeof a?a:r.SQL._nullDataHandler,r.SQL._errorHandler)},r.SQL._errorHandler)},r.SQL._errorHandler)},r.SQL._errorHandler)},r.SQL._errorHandler):"function"==typeof a&&a()},t)},l.prototype.createVariable=function(t,a){var r=this;this.SQL.getExistingTables(function(n){if(!1===e.includes(n,"variable")){r.SQL.executeSql(t,"CREATE TABLE variable( name TEXT NOT NULL PRIMARY KEY, type TEXT, value TEXT NOT NULL);",[],r.SQL._nullDataHandler,r.SQL._errorHandler),r.SQL._existingTables=null;var i=(new Date).getTime();r.SQL.executeSql(t,'insert into variable (name, value) VALUES ("lastReviewDate", "'+i+'");',[],function(){r.SQL.executeSql(t,'insert into variable (name, value) VALUES ("nbDayRegularity", "0");',[],function(){r.SQL.executeSql(t,'insert into variable (name, value) VALUES ("FirstRunTime", "'+i+'");',[],"function"==typeof a?a:r.SQL._nullDataHandler,r.SQL._errorHandler)},r.SQL._errorHandler)},r.SQL._errorHandler)}else"function"==typeof a&&a()},t)},l.prototype.createUserVariable=function(t,a){var r=this;r.SQL.getExistingTables(function(n){!1===e.includes(n,"user_variable")?(r.SQL.executeSql(t,i,[],"function"==typeof a?a:r.SQL._nullDataHandler,r.SQL._errorHandler),r.SQL._existingTables=null):"function"==typeof a&&a()},t)},l.prototype.containsTable=function(t,a){var r=this;r.SQL.database.transaction(function(n){r.SQL.getExistingTables(function(r){var n=e.includes(r,t);a(n)},n)})},l.prototype.dropMosaContent=function(e,t){var a=this;this.SQL.database.transaction(function(e){a.SQL.executeSql(e,'DROP TABLE IF EXISTS "card";',[],function(){a.SQL.executeSql(e,'DROP TABLE IF EXISTS "category";',[],t,a.SQL._errorHandler)},a.SQL._errorHandler)})},l.prototype.updateOrPopulateDB=function(e,t){var a=this,r=[{name:"createUserCardTable",tx:!1},{name:"createUserCategoryTable",tx:!1},{name:"createVariable",tx:!1},{name:"createUserVariable",tx:!1},{name:"createUserStat",tx:!1},{name:"createCardStatTable",tx:!1},{name:"dropMosaContent",tx:!1},{name:t?"createMosaContentWithDownloadedCards":"createMosaContentWithShippedCards",tx:!0},{name:"createCategoryView",tx:!1},{name:"importUserCards",tx:!0},{name:"relinkMosaContent",tx:!1}];this.SQL.database.transaction(function(t){d(t,a,r,e)})},l.prototype.createVariablesTables=function(e){var t=this,a=[{name:"createVariable",tx:!1},{name:"createUserVariable",tx:!1}];t.SQL.database.transaction(function(r){d(r,t,a,e)})},l.prototype.loadLatestContent=function(e,t){var a=this,r=[{name:"dropMosaContent",tx:!1},{name:"createMosaContentWithLatestContent",tx:!0},{name:"createCategoryView",tx:!1},{name:"importUserCards",tx:!0},{name:"relinkMosaContent",tx:!1}];this.SQL.database.transaction(function(n){d(n,a,r,e,t)})},l.prototype.getUpdatedContentFromS3=function(e,t){var a=this,r=[{name:"dropMosaContent",tx:!1},{name:"createMosaContentWithLatestContentFromS3",tx:!0},{name:"createCategoryView",tx:!1},{name:"importUserCards",tx:!0},{name:"relinkMosaContent",tx:!1}];this.SQL.database.transaction(function(n){d(n,a,r,e,t)})},l});