define(["jquery","underscore","q","models/Cards","models/LevelSearch","models/Level","models/Variable","utils/Localization","utils/ViewUtils","utils/Constants","utils/Device","utils/CardType","utils/database/SQL","utils/Logger","utils/SoundManager","utils/Media","utils/UserParams","utils/Tutorial","utils/DynSTR","utils/ViewReadyMixin","views/FlashcardBaseMixin","views/ImageFlashcardMixin","views/WritingFlashcardMixin","views/RecordCompareFlashcardMixin","text!templates/flashcard/flashcardCardViewTemplate.html","text!templates/flashcard/flashcardInnerViewTemplate.html","text!templates/flashcard/flashcardViewWithHeaderTemplate.html","text!templates/flashcard/levelTestContentHeaderTemplate.html","utils/Diff"],function(e,t,r,a,i,s,n,l,d,o,c,h,u,v,C,p,f,g,T,m,w,L,x,b,S,R,F,y){var O=function(e){for(var r,a=-1,i=[],s=0;s<e.length;s++){var n=e[s];if(a!=n.attributes.level){if(r){var l=t.shuffle(r);i.push.apply(i,l)}r=[],a=n.attributes.level}r&&r.push(n)}return r&&i.push.apply(i,t.shuffle(r)),i},k={events:{"click .btn-returncard":"handleReturnCard","click .btn-answer":"handleLevelTestAnswer","click .btn-listen":"play","click .with-sound.action-listen":"play","click .details":"playExample","click .btn-volume":"toggleVolumeSlider","click .btn-back":"goBack"},handlers:{prepare:"prepareLevelView",render:"renderLevelView",close:"closeLevelView"},isFlat:!0,isActive:function(e){return e.indexOf("levelTest")>-1},prepareViewParams:function(e){return this.prepareViewParamsBase(e)},prepareCardList:function(){for(var e,r,a=this.cards.models,s={},n=0;n<a.length;n++){var l=a[n].attributes.level;(void 0===e||a[n].attributes.level<e)&&(e=a[n].attributes.level),(void 0===r||a[n].attributes.level>r)&&(r=a[n].attributes.level),s[l]=s[l]?s[l]+1:1,n%2==0&&h.isWritingModeEnabledForCard(a[n].attributes)?a[n].attributes.mode=o.MODE_WRITE:a[n].attributes.mode=o.MODE_LEARNTO}v.debugOnTopic("level-search","all levels: ["+e+", "+r+"]"),this.cardsByLevel={};for(var d=e;d<r+1;d++)(!s[d]||s[d]<3)&&v.warn("Not enough cards for level test on level: "+d),this.cardsByLevel[d]=t.filter(a,function(e){return e.attributes.level===d});return this.levelSearch=new i(e,r,3),this.takeNextCard(!0),this},prepareCard:function(e,t){var r=this.prepareCardBase(e,t);return e===o.MODE_WRITE?r=this.getCardForView(t,r,!0):e!==o.MODE_RECORD_COMPARE&&this.prepareCardImageFlashcard(e,t,r),r},handleReturnCard:function(){return g.cleanCurrentTooltip(),this.getMode(this.currentCard)===o.MODE_WRITE&&(this.handleReturnWritingMode(),this.renderBackCardTooltips()),this.handleReturnCardBase()},getNextCardForCurrentLevel:function(){var e;return function(t){t&&(this.excerciseCount=0,e=null);var r,a=!1,i=this.levelSearch.getCurrentLevel();return e&&i!=e&&(this.excerciseCount=0),v.debugOnTopic("level-search","Level: "+i+", this.excerciseCount: "+this.excerciseCount+", # cards in level: "+this.cardsByLevel[i].length),this.cardsByLevel[i]&&this.excerciseCount<this.cardsByLevel[i].length&&(a=!0,r=this.cardsByLevel[i][this.excerciseCount],this.excerciseCount++,e=i),a?r:void 0}}(),hasEnoughLevelTestCards:function(){return this.cardsByLevel[this.levelSearch.getCurrentLevel()].length>=2},takeNextCard:function(e){var t=this;for(g.cleanCurrentTooltip(),this.levelSearch.canAdvance()&&(this.levelSearch.advance(),this.currentCard=this.nextCard=null,this.excerciseCount=0),!this.levelSearch.isFound()&&this.excerciseCount&&!this.nextCard&&this.cardsByLevel[this.levelSearch.getCurrentLevel()].length<=this.excerciseCount&&(this.levelSearch.advance(),this.currentCard=this.nextCard=null,this.excerciseCount=0);!this.levelSearch.isFound()&&!this.hasEnoughLevelTestCards();)this.levelSearch.advanceForEmptyLevel(),this.currentCard=this.nextCard=null,this.excerciseCount=0;return this.levelSearch.isFound()?(t.updateLevelTestProgress(),!1):(this.nextCard?this.currentCard=this.nextCard:this.currentCard=this.getNextCardForCurrentLevel(e),this.nextCard=this.getNextCardForCurrentLevel(),this.currentCard||v.warn("failed to take next card",this.levelSearch.getCurrentLevel()),t.updateLevelTestProgress(),!0)},getMode:function(e){return e&&e.attributes?e.attributes.mode:null},prepareLevelView:function(){var t=this;this.initViewReady(),this.prepareImageFlashcard(),this.setupWriting.call(this),this.level=new s,this.visible={flashcard1:!0,flashcard2:!1},this.doWhenVisible(function(){var t=e(".flashcard-header").outerHeight();"0px"===e(".flashcard-container",e(this.el)).css("top")&&t>0&&e(".flashcard-container",e(this.el)).css("top",t+"px")}),this.cards=new a,this.listenTo(this.cards,"sync",function(){this.cards.models=O(this.cards.models),t.prepareCardList(),g.addTooltip("frontGuidance",null,null,{xOffset:"center",arrowOffset:"center",alwayShow:!0}),g.addTooltip("frontGuidanceWriting",null,null,{xOffset:"center",placement:"top",arrowOffset:"center",alwayShow:!0,yOffset:0}),g.addTooltip("backGuidanceWriting",null,l.STR.tooltipLevelTestWritingBackGuide,{xOffset:"center",placement:"top",arrowOffset:"center",alwayShow:!0}),t.renderCards(),t.renderCurrentCard()}),this.cards.fetch({mode:"levelTestCards",cardCountPerLevel:3})},renderLevelView:function(){var r=t.template(F),a=t.template(y);e(this.el).html(r({flashcardInnerViewTemplate:R,STR:l.STR,isCanSkip:void 0===this.options.end||isNaN(this.options.end),topActions:[{name:"back",classes:"btn-flat btn-round btn-back"}],topContent:a({STR:l.STR})}))},renderCard:function(r,a){r&&v.debugOnTopic("flashcard","renderCard, id:"+r.attributes.id+', "'+r.attributes.original+'", el# '+a.data("seq"));var i=this,s=this.getMode(r),n=i.prepareViewParams(s);n=t.extend(n,{card:this.prepareCard(s,r),isMonoLingual:h.isMonoLingualCard(r.attributes),showDetailsLink:!1}),e(".flashcard-container",e(this.el)).css("top",e(".flashcard-header",e(this.el)).outerHeight()+"px");var l=t.template(S);a.html(l(n)),a.data("card_id",r.attributes.id)},renderFrontCardTooltips:function(){var t=!1,r=!1;return function(){var a=this;this.doWhenVisible(function(){if(a.getMode(a.currentCard)!==o.MODE_WRITE||r){if(!t){var i=h.isMonoLingualCard(a.currentCard.attributes),s=i?l.STR.tooltipLevelTestFrontGuideMono:l.STR.tooltipLevelTestFrontGuide;g.displayTooltip("frontGuidance",e(".btn-returncard"),s.replace("{word}",i?a.currentCard.attributes.original:a.currentCard.attributes.translation).replace("{lang}",T.get_originalLngName())),t=!0}}else g.displayTooltip("frontGuidanceWriting",e(".writing-keyboard",a.getCurrentFlashCardEl()),l.STR.tooltipLevelTestWritingFrontGuide.replace("{word}",a.currentCard.attributes.translation).replace("{lang}",T.get_originalLngName())),r=!0})}}(),renderBackCardTooltips:function(){var t=!1;return function(){t||this.listenToOnce(this,"back-actions-bar-toggled",function(){g.displayTooltip("backGuidanceWriting",e(".training",e(this.el))),t=!0})}}(),renderCurrentCard:function(){this.toggleFrontActionsBar(),this.renderFrontCardTooltips(),e(".current-level",e(this.el)).html(this.currentCard.attributes.level)},handleBaseTrainingAnswer:function(t){this.isCorrect=void 0,"correct"===e(t.currentTarget).attr("data-answer")?this.levelSearch.markAsCorrect():this.levelSearch.markAsInCorrect(),this.restoreButtons(),this.swapButtonLegend(l.STR.RepeatAndRecord),this.hidePlayingRecordAnimation(),this.recordedFile=null,this.nextFlashCard()},updateLevelTestProgress:function(){var t=this.levelSearch.getProgress();v.debugOnTopic("level-search","progress: "+t+", level: "+this.levelSearch.getCurrentLevel()),0===t&&(t=5),e(".wizard-leveltest-progress span",e(this.el)).css({width:t+"%"}),100===t&&e(".wizard-leveltest-progress",e(this.el)).addClass("done")},handleLevelTestAnswer:function(e){this.handleBaseTrainingAnswer(e)},nextFlashCard:function(){var e=this;e.hideContentBeforeRemoveFlashcard(),e.takeNextCard()?(e.currentCard.attributes.id!==e.getNextFlashCardEl().data("card_id")&&(v.debugOnTopic("flashcard","JIT rendering"),e.renderCard(e.currentCard,e.getNextFlashCardEl())),e.toggleBackActionsBar(e.currentCard),c.isIOS||e.showContentAfterRemoveFlashcard(),e.showNextCard().then(function(){var t=e.getNextFlashCardEl();e.nextCard&&e.renderCard(e.nextCard,t),e.trigger("cardRendered",e.getCurrentFlashCardEl()),e.getMode(e.currentCard)===o.MODE_RECORD_COMPARE&&e.playListeningCard(),c.isIOS&&e.showContentAfterRemoveFlashcard(),e.renderCurrentCard()})):e.finish()},finish:function(){(new n).setValue("displayLearningStackOptions",!1),this.level.setCurrentLevel(this.levelSearch.getCurrentLevel()),this.nextStep()},closeLevelView:function(){this.onCloseImageFlashcard(),this.tearDownWriting()}};return t.defaults(k,w),t.defaults(k,L),t.defaults(k.events,L.imageEvents),t.defaults(k,x),t.defaults(k.events,x.events),t.defaults(k,b),t.defaults(k.events,b.events),t.defaults(k,m),k});